POJ 3126 Prime Path 素数筛法+BFS STL中pair模板使用

Description
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.
Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
3
1033 8179
1373 8017
1033 1033
Sample Output
6
7
0

题目大意:
给你两个四位数的质数a, b, 对a进行操作使之变成b
每一次操作只能该改变 a 的一个位,并且改变后的数必须是一个质数。整个过程中涉及到的质数都是四位数的质数,没有前导零。
问最少的操作次数是多少。

解题思路:
我是先用素数筛法筛选出了10000以内的所有质数,题目中有“最少”字眼,很容易想到用广度优先搜索(BFS),每一次把我们筛选出来的质数中,与上一质数只有一位不同的所有质数全部加入到队列中并标记这些数,下次遇到的时候就不用再加入队列了。当搜索到答案时返回步数。如果直到队列为空也没有搜索到答案,返回-1,代表无法实现.

AC代码:

#include<iostream>
#include<queue>
#include<stdio.h>
using namespace std;
#define maxn 10000
bool mark[maxn];
bool use[maxn];
typedef pair<int, int>P;
queue<P> q;
void init() {//筛选出10000以内的所有质数
	for (int i = 1; i < maxn; i++) {
		mark[i] = false;
	}
	for (int i = 2; i < maxn; i++) {
		if (mark[i])continue;
		/*注意这里j不能从i开始,因为我们要用
		mark[i]==fasle来判断数i是质数
		由于我的个人习惯,即让j从i开始,还WA了一次。。。*/
		for (int j = i * 2; j < maxn; j += i) {
			mark[j] = true;
		}
	}
}
int BFS(int nn, int mm, int step) {
	while (!q.empty())q.pop();
	for (int i = 1; i < maxn; i++) {//不要忘记这一步的初始化
		use[i] = false;
	}
	P f; f.first = nn; f.second = step;
	q.push(f);
	while (!q.empty()) {
		P n = q.front();
		q.pop();
		if (n.first == mm)return n.second;
		int a, b, c, d;
		a = n.first / 1000; n.first %= 1000;
		b = n.first / 100; n.first %= 100;
		c = n.first / 10; n.first %= 10;
		d = n.first;
		for (int i = 0; i < 10; i++) {
			int tmp;
			if (i != 0 && i != a) {//不能有前导零
				tmp = i * 1000 + b * 100 + c * 10 + d;
				if (!mark[tmp] && !use[tmp]) {//素数
					q.push(P(tmp, n.second + 1));
					use[tmp] = true;
				}
			}
			if (i != b) {
				tmp = a * 1000 + i * 100 + c * 10 + d;
				if (!mark[tmp] && !use[tmp]) {//素数
					q.push(P(tmp, n.second + 1));
					use[tmp] = true;
				}
			}
			if (i != c) {
				tmp = a * 1000 + b * 100 + i * 10 + d;
				if (!mark[tmp] && !use[tmp]) {//素数
					q.push(P(tmp, n.second + 1));
					use[tmp] = true;
				}
			}
			if (i != d) {
				tmp = a * 1000 + b * 100 + c * 10 + i;
				if (!mark[tmp] && !use[tmp]) {//素数
					q.push(P(tmp, n.second + 1));
					use[tmp] = true;
				}
			}
		}
	}
	return -1;
}
int main() {
	int n, m, t;
	init();
	cin >> t;
	while (t--) {
		scanf("%d%d", &n, &m);
		int ans = BFS(n, m, 0);
		if (ans != -1) { cout << ans << endl; }
		else cout << "Impossible" << endl;
	}
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值